Summary: A public domain shell implementing ksh-88
Name: pdksh
Version: 5.2.14
Release: 36%{?dist}
License: Public Domain
Group: System Environment/Shells
Patch0: pdksh-5.2.14-manloc.patch
Patch1: pdksh-5.2.14-patches1.patch
Patch2: pdksh-5.2.14-alignia64.patch
Patch3: pdksh-5.2.14-patches2.patch
Patch4: pdksh-noninteractive.patch
Patch5: pdksh-emacsmode.patch
Patch6: pdksh-5.2.14-ptr.patch
Patch7: pdksh-5.2.14-sortsyntax.patch
Patch8: pdksh-5.2.14-sane-alloc2.patch
Patch9: pdksh-5.2.14-multilineprompt.patch
Patch10: pdksh-5.2.14-segfault.patch
Patch11: pdksh-5.2.14-aliases.patch
Source: ftp://ftp.cs.mun.ca/pub/pdksh/pdksh-%{version}.tar.gz
URL: http://www.cs.mun.ca/~michael/pdksh/
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Requires: chkconfig
Requires(preun): chkconfig
Requires(post): chkconfig

%description
The pdksh package contains public domain implementation of ksh-88.
The ksh shell is a command interpreter intended for both interactive
and shell script use. Ksh's command language is a superset of the sh
shell language.

Pdksh is unmaintained since 1998 and is obsoleted by ksh package.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

%build
export CFLAGS="$RPM_OPT_FLAGS -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE"
%configure --bindir=/bin
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall bindir=$RPM_BUILD_ROOT/bin

chmod -x etc/sys_config.sh

#we need /bin/pdksh , man1/pdksh.1.gz
#and links (alternatives) :
#   /bin/ksh, /usr/bin/ksh and man1/ksh.1.gz
mkdir -p $RPM_BUILD_ROOT%{_bindir}
# prepare man1/pdksh.1.gz
mv $RPM_BUILD_ROOT%{_mandir}/man1/ksh.1 $RPM_BUILD_ROOT%{_mandir}/man1/pdksh.1
gzip $RPM_BUILD_ROOT%{_mandir}/man1/pdksh.1
# prepare /bin/pdksh
mv $RPM_BUILD_ROOT/bin/ksh $RPM_BUILD_ROOT/bin/pdksh
# fool rpmdiff about %ghost files (#495040)
touch $RPM_BUILD_ROOT/bin/ksh
touch $RPM_BUILD_ROOT%{_bindir}/ksh
touch $RPM_BUILD_ROOT%{_mandir}/man1/ksh.1.gz

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ ! -f /etc/shells ]; then
     echo "/bin/ksh" > /etc/shells
else
     if ! grep -q '^/bin/ksh$' /etc/shells ; then
          echo "/bin/ksh" >> /etc/shells
     fi
fi
if ! grep -q '^/usr/bin/ksh$' /etc/shells ; then
     echo "/usr/bin/ksh" >> /etc/shells
fi
if ! grep -q '^/usr/bin/pdksh$' /etc/shells ; then
     echo "/usr/bin/pdksh" >> /etc/shells
fi

%{_sbindir}/alternatives --install /bin/ksh ksh \
                /bin/pdksh 10 \
        --slave %{_bindir}/ksh ksh-usrbin \
                /bin/pdksh \
        --slave %{_mandir}/man1/ksh.1.gz ksh-man \
                %{_mandir}/man1/pdksh.1.gz

%preun
if [ $1 = 0 ]; then
        %{_sbindir}/alternatives --remove ksh /bin/pdksh
fi

%postun
if [ ! -f /bin/ksh ]; then
     sed -i -e '/^\/bin\/ksh/ d' -e '/^\/usr\/bin\/ksh/ d' \
     -e '/^\/usr\/bin\/pdksh/ d' /etc/shells
fi

%verifyscript

echo -n "Looking for ksh in /etc/shells... "
if ! grep '^/bin/ksh$' /etc/shells > /dev/null; then
     echo "missing"
     echo "ksh missing from /etc/shells" >&2
else
     echo "found"
fi

%files
%defattr(-,root,root)
%doc README NOTES PROJECTS NEWS BUG-REPORTS LEGAL etc
/bin/pdksh
%ghost /bin/ksh
%ghost %{_bindir}/ksh
%ghost %{_mandir}/man1/ksh.1.gz
%{_mandir}/man1/pdksh.1.gz

%changelog
* Wed Sep 16 2009 Anatoly Metetes <anatolym@startcom.org>
- Rebuild for StartCom Linux 5.0.x

* Thu Apr 16 2009 Michal Hlavinka <mhlavink@redhat.com> 5.2.14-36
- fix debuginfo package (rpmbuild added %%ghost files to pdksh-debuginfo)
- resolves: #469297

* Mon Mar 09 2009 Michal Hlavinka <mhlavink@redhat.com> 5.2.14-35
- add 'dist' to release tag
- resolves: #469297

* Fri Mar 06 2009 Michal Hlavinka <mhlavink@redhat.com> 5.2.14-34
- update requires
- resolves: #469297

* Fri Mar 06 2009 Michal Hlavinka <mhlavink@redhat.com> 5.2.14-33
- bump release number (greater than 32 is needed)
- resolves: #469297

* Wed Feb 18 2009 Michal Hlavinka <mhlavink@redhat.com> 5.2.14-31
- use alternatives for ksh/pdksh selection
- spec cleanup
- initial package for RHEL-5
- resolves: #469297

* Thu Jun 21 2007 Tomas Smetana <tsmetana@redhat.com> 5.2.14-30.6
- fix segfaulting (#186422, #193670)

* Thu Sep 28 2006 Karsten Hopp <karsten@redhat.de> 5.2.14-30.5
- bump release

* Thu Sep 28 2006 Karsten Hopp <karsten@redhat.de> 5.2.14-30.4
- RHBA-2006:0704
- fix signal handling (#200879)
- fix memory handling (#186422)
- add fix for multiline prompts (#198734)

* Mon Aug 08 2005 Karsten Hopp <karsten@redhat.de> 5.2.14-30.3
- save ptr before calling shell()

* Tue Jun 21 2005 Karsten Hopp <karsten@redhat.de> 5.2.14-30.2
- RHBA-2005:538
- fix commandline prompt in emacs/gemacs modes (#159061)

* Thu Mar 31 2005 Karsten Hopp <karsten@redhat.de> 5.2.14-30.1
- don't wait for tty input in non-interactive scripts (#149325)

* Wed Jul 07 2004 Karsten Hopp <karsten@redhat.de> 5.2.14-30
- rebuild with new gcc

* Mon Jul 05 2004 Karsten Hopp <karsten@redhat.de> 5.2.14-29 
- add etc/* files from tarball to documentation as examples (#126843)

* Sat Jun 19 2004 Alan Cox <alan@redhat.com>
- EASYFIX (#125678) - add/remove alias /usr/bin/ksh, pdksh names. Fix
  inadequate grep anchors on remove script. Fix wrong permissions if
  upgrading with umask 077.

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Jun 03 2003 Karsten Hopp <karsten@redhat.de> 5.2.14-22
- rebuild for AS to support large files (#76307, #87937)

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Nov 19 2002 Tim Powers <timp@redhat.com>
- rebuild on all arches

* Fri Jun 28 2002 Trond Eivind Glomsrod <teg@redhat.com> 5.2.14-19
- Make it handle large files by adding compiler flags (#67662)

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Feb 27 2002 Trond Eivind Glomsrod <teg@redhat.com> 5.2.14-16
- Rebuild

* Wed Jan 16 2002 Trond Eivind Glomsrod <teg@redhat.com> 5.2.14-15
- Rebuild

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.

* Sun Feb 25 2001 Trond Eivind Glomsrod <teg@redhat.com>
- Add patch from author to fix some init problems

* Tue Jan 23 2001 Trond Eivind Glomsrod <teg@redhat.com>
- add fileutils and grep to PreReq: (#24720)

* Mon Jan 08 2001 Trond Eivind Glomsrod <teg@redhat.com>
- add patch to fix alignment problems on IA64 (#23351)

* Tue Nov 28 2000 Trond Eivind Glomsrod <teg@redhat.com>
- redid some patches, which should fix #19517

* Mon Aug 14 2000 Trond Eivind Glomsrod <teg@redhat.com>
- use relative symlinks (#16127)

* Sat Jul 29 2000 Trond Eivind Glomsrod <teg@redhat.com>
- added patch to handle readonly variables correctly

* Mon Jul 24 2000 Trond Eivind Glomsrod <teg@redhat.com>
- add patch from author to fix "-x" problem (#10758)
- add another author patch (some fixes wrt. job handling)

* Fri Jul 21 2000 Trond Eivind Glomsrod <teg@redhat.com>
- add URL
- use %%makeinstall and add a patch to make it work

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Tue Jun 13 2000 Trond Eivind Glomsrod <teg@redhat.com>
- use %%{_mandir}, %%configure and %{_tmpdir}

* Mon Feb  7 2000 Jeff Johnson <jbj@redhat.com>
- compress man pages.

* Tue Jul 20 1999 Jeff Johnson <jbj@redhat.com>
- update to 5.2.14.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Wed Mar 17 1999 Jeff Johnson <jbj@redhat.com>
- glibc 2.1 doesn't init sys_siglist for 32 <= i < NSIG (#1473)

* Fri Mar 12 1999 Jeff Johnson <jbj@redhat.com>
- upgrade to 5.2.13.

* Sun Aug 16 1998 Jeff Johnson <jbj@redhat.com>
- build root

* Mon Apr 27 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed Oct 21 1997 Cristian Gafton <gafton@redhat.com>
- fixed the spec file

* Fri Jul 18 1997 Erik Troan <ewt@redhat.com>
- built against glibc
